	.dbfile C:\iccv7arm\MI533D~1\MICROB~2\MicroBoltExtIntEdge.c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_main:
	.dbline -1
	.dbline 38
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBoltExtIntEdge.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 4/2/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; 
; #include "MicroBoltExtIntEdge.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void main(void)
;   {
	.dbline 46
; 
; /*
; |----------------------------------------------------
; |     MicroBolt hardware setup 
; |----------------------------------------------------
; */
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 48
; 
;   SCB_PLLCFG |= 0x23;				 	   		            // Turn on PLL, set to 59 MHz (0x03 is multiply value of 4)
	ldr R0,LIT_main+0
	ldr R1,[R0,#0]
	orr R1,R1,#35
	str R1,[R0,#0]
	.dbline 49
;   SCB_PLLCON |= 0x03;
	ldr R0,LIT_main+4
	ldr R1,[R0,#0]
	orr R1,R1,#3
	str R1,[R0,#0]
	.dbline 50
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy for PLL
	mov R0,#170
	ldr R1,LIT_main+8
	str R0,[R1,#0]
	.dbline 51
;   SCB_PLLFEED = 0x55; 
	mov R0,#85
	ldr R1,LIT_main+8
	str R0,[R1,#0]
	.dbline 53
; 
;   PCB_PINSEL0=0x00000000;                       // JTAG is via secondary port
	mov R0,#0
	ldr R1,LIT_main+12
	str R0,[R1,#0]
	.dbline 54
;   PCB_PINSEL1=0x55400000;
	ldr R0,LIT_main+16
	ldr R1,LIT_main+20
	str R0,[R1,#0]
	.dbline 55
;   GPIO_IODIR=(0x00000000<<16)|
	mov R0,#0
	ldr R1,LIT_main+24
	str R0,[R1,#0]
	.dbline 58
; 	     0x00000000;
;  
;   GPIO_IOCLR=0xffffffff;
	mvn R0,#0
	ldr R1,LIT_main+28
	str R0,[R1,#0]
	.dbline 59
;   GPIO_IOSET=(0x00000000<<16)| 
	mov R0,#0
	ldr R1,LIT_main+32
	str R0,[R1,#0]
	.dbline 62
;             0x00000000;  
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R0,LIT_main+24
	ldr R1,[R0,#0]
	orr R1,R1,#4194304
	str R1,[R0,#0]
	.dbline 64
; 
;   PCB_PINSEL0 |= P0_14_EXTERNAL_INTERRUPT_1;    // Setup P0.14 to alternate function EINT1
	ldr R0,LIT_main+12
	ldr R1,[R0,#0]
	orr R1,R1,#536870912
	str R1,[R0,#0]
	.dbline 66
; 
;   VICVectAddr0 = (unsigned)ExtInt1_ISR;         // Assign the EINT1 ISR function to VIC priority 0
	ldr R0,LIT_main+36
	ldr R1,LIT_main+40
	str R0,[R1,#0]
	.dbline 67
;   VICVectCntl0 = INTERRUPT_CHANNEL_FOR_EINT1;   // Assign the VIC channel EINT1 to interrupt priority 0
	mov R0,#47
	ldr R1,LIT_main+44
	str R0,[R1,#0]
	.dbline 69
; 
;   VICIntEnable |= INTERRUPT_ENABLE_FOR_EINT1;   // Enable the EINT1 interrupt 
	ldr R0,LIT_main+48
	ldr R1,[R0,#0]
	orr R1,R1,#32768
	str R1,[R0,#0]
	.dbline 71
; 
;   __ENABLE_INTERRUPT();                         // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
	b L3
L2:
	.dbline 80
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
; 
;   while(1)                                          // Do this forever
;     {
	.dbline 81
;     GPIO_IOCLR = MICROBOLT_LED;                     // MicroBolt LED Off   
	mov R0,#4194304
	ldr R1,LIT_main+28
	str R0,[R1,#0]
	.dbline 83
; 
;     if (GPIO_IOPIN & P0_14)                         // P0.14/EINT1 input line high?
	ldr R0,LIT_main+52
	ldr R0,[R0,#0]
	tst R0,#16384
	beq L5
	.dbline 84
;       {
	.dbline 85
;       SCB_EXTINT |= EXTINT_CLR;                     // Clear interrupt in case any left over
	ldr R0,LIT_main+56
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 86
;       PCB_PINSEL0 |= P0_14_EXTERNAL_INTERRUPT_1;    // Set pin function back to EINT1
	ldr R0,LIT_main+12
	ldr R1,[R0,#0]
	orr R1,R1,#536870912
	str R1,[R0,#0]
	.dbline 87
;       VICIntEnable |= INTERRUPT_ENABLE_FOR_EINT1;   // Enable EINT1 interrupt.              
	ldr R0,LIT_main+48
	ldr R1,[R0,#0]
	orr R1,R1,#32768
	str R1,[R0,#0]
	.dbline 88
;       }
L5:
	.dbline 90
L3:
	.dbline 79
	b L2
X0:
	.dbline -2
L1:
	mov R15,R14
	.dbline 0 ; func end
LIT_main:
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD -536707060
	DCD -536707068
	DCD _ExtInt1_ISR
	DCD -3840
	DCD -3584
	DCD -4080
	DCD -536707072
	DCD -534789824
	.dbend
	EXPORT _ExtInt1_ISR
	.dbfunc e ExtInt1_ISR _ExtInt1_ISR fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;          Delay -> R4
_ExtInt1_ISR:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R2,R4,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 102
; 
;     }
;   }                                                 // end of main
; 
; /*
; |----------------------------------------------------
; |     External Interrupt-1 Interrupt Service Routine
; |----------------------------------------------------
; */
; 
; #pragma interrupt_handler ExtInt1_ISR
; 
; void ExtInt1_ISR(void)                          // Come here whenever there is a low level on EINT1
;   {  
	.dbline 105
; 	unsigned int Delay;
; 
;   VICIntEnClear = INTERRUPT_ENABLE_FOR_EINT1;   // Disable the external interrupt
	mov R0,#32768
	ldr R1,LIT_ExtInt1_ISR+0
	str R0,[R1,#0]
	.dbline 106
;   PCB_PINSEL0 &= ~P0_14_EXTERNAL_INTERRUPT_1;   // Make EINT1 a GPIO input for P0.14 now
	ldr R0,LIT_ExtInt1_ISR+4
	mvn R1,#536870912
	ldr R2,[R0,#0]
	and R1,R2,R1
	str R1,[R0,#0]
	.dbline 108
; 
;   GPIO_IOSET = MICROBOLT_LED;                   // MicroBolt LED On
	mov R0,#4194304
	ldr R1,LIT_ExtInt1_ISR+8
	str R0,[R1,#0]
	.dbline 109
	mov R4,#0
	b L11
L8:
	.dbline 109
L9:
	.dbline 109
	add R4,R4,#1
L11:
	.dbline 109
;   for (Delay = 0; Delay < 78000; Delay++);      // Delay for 100 mS 
	ldr R0,LIT_ExtInt1_ISR+12
	cmp R4,R0
	blo L8
	.dbline 111
; 
;   SCB_EXTINT |= EXTINT_CLR;                     // Clear interrupt
	ldr R0,LIT_ExtInt1_ISR+16
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 112
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_ExtInt1_ISR+20
	str R0,[R1,#0]
	.dbline -2
L7:
	ldmfd R13!,{R0,R1,R2,R4,R11,R12,PC}^
	.dbline 0 ; func end
LIT_ExtInt1_ISR:
	DCD -4076
	DCD -536690688
	DCD -536707068
	DCD 78000
	DCD -534789824
	DCD -4048
	.dbsym r Delay 4 i
	.dbend
	END
